__OVERVIEW__

| Project         | pask
|:----------------|:--------------------------------------------------
| Homepage        | https://github.com/robgleeson/pask
| Build           | [![Build Status](https://travis-ci.org/robgleeson/pask.png?branch=master)](https://travis-ci.org/robgleeson/pask)

__DESCRIPTION__

pask is a concurrent tracer written with the power of `Thread#set_trace_func`.

__EXAMPLES__

```ruby
tracer = Pask.new
tracer.trace { Person.call }
event1 = tracer.start # the event for "Person.call called"
event2 = tracer.resume # the event for "Person.call returned"
event3 = tracer.resume # returns nil (no more code to trace)
```

__REPL IN YO TRACER__

pask produces instance's of `Pask::Event` when it traces code. an event is returned to
the caller and opens up some exciting possibilities(due to the wonders of `Binding`):

```ruby
def call
  x = 1
  p x
end

tracer = Pask.new
tracer.trace { Person.call }
event1 = tracer.start
event.binding.pry # start pry inside 'call', before assignment of x.
```

__RUBIES__

- MRI
  - 1.9.2
  - 1.9.3
  - 2.0.0
  - 2.1.0
  - 2.1.0+

__CONTRIBUTE!__

[fork it](https://github.com/robgleeson/binding.repl/fork), clone it, change! <br>
open a pull request :)

some tips for working on the project:
```
cd $CLONED_DIR
bundle install
rake test # run tests
```

__INSTALL__

    $ gem install pask

__SEE ALSO__

- [machine.repl](https://github.com/robgleeson/machine.repl)<br>
  the webmachine-ruby repl/debugger.

- [examples/ directory](https://github.com/robgleeson/pask/tree/master/examples)<br>
  examples in the `examples/` directory. `$ rake examples` runs em all.

__LICENSE__

see UNLICENSE.txt. public domain.
